<?php
/***************************************************************************
 *                               func_fb2i1.php
 *                            FB2IMP functions
 *                            -------------------
 *   begin                : Tuesday, Apr 22, 2006
 *   copyright            : (C) 2010 Ulrich Schroeter
 *
 *     added              : Friday, July 28, 2006
 *                        : function hmac()
 *     modified           : updatearea() rep061030.032
 *     updated            : version() v2.05 rep061031.033
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 * See the LICENSE file for more information.
 * DLIMP Website : http://ambrosia60.dnsalias.net/
 *----------------------------------------------------------------------------
 */


define('MSGIMP',1);

//=================================================

/* ---------  begin funtions ------------------------------ */

//      188  BC | nextReply (low order) | nextReply (high order)|
//              +-----------------------+-----------------------+
//  $nxtReply = dbl2val(fread($f,2));
function dbl2val($dblbyte) {
  $c1 = substr($dblbyte,0,1);
  $c2 = substr($dblbyte,1,1);
  $val = ord($c1)+ (ord($c2) * 256);
  return $val;
}

function Get_origin_address($addr_msv,$msgf="") {
  if (isset($addr_msv[4])) {
    $res=$addr_msv[1].':'.$addr_msv[2].'/'.$addr_msv[3].($addr_msv[4]?'.'.$addr_msv[4]:'');
  } elseif (isset($addr_msv[3])) {
    $res=$addr_msv[1].':'.$addr_msv[2].'/'.$addr_msv[3];
  } else {
    $res = "0:0/0.0";
    logfile('E',"invalid origin line, get AKA failed: ".$msgf);
    logfile('D',"invalid origin line, get AKA failed: ".$msgf);      
  }
  return $res;
}

function fgetint($file,$len) {
	$result=0;
	for ($i=0;$i<$len;$i++):
		$result+=(ord(fgetc($file)) << ($i*8));
	endfor;
	return $result;
}

function refn($mode=0,$subj,$patt="") {
  // mode = 0  detect
  // mode = 1  replace
  if (preg_match("/^Re(\^\d+){0,1}:/",$subj)) {
    // if (preg_match("/^(Re\^\d{1,2}|Re)\:/",substr($subj,0,5))) {
    // echo "pregmatch found: ".$subj."\r\n";
    if ($mode==0) {
      return True;
    } else {
      if  (preg_match("/^Re:/",$subj)) {
        // simple Re: ... Re: ...
        while (substr($subj,0,3)=="Re:") {
          $subj = trim(substr($subj,at("Re:",$subj)+3));
        } 
      } else {
        $subj = trim(preg_replace("/^Re(\^\d+){0,1}:/",$patt,$subj));
      }
      return $subj;
    }
  } else {
    // echo "pregmatch not found\r\n";
    if ($mode==0) {
      return False;
    } else {
      return $subj;
    }
  }  
}


//  if (!dupefind($folder,$ftscdateA,$msgid,$subject)) {
function dupefind($msgf,$fld,$fdat,$msgid,$subj) {
  // SELECT * FROM fidobase2.echo_f where `folder`='FIDOCON.BLEICHENBACH.1996' and `ftscdate` like '08 Dec 09  21:20:4%' and `msgid`='2:240/2188.262 4b1eb5bf' and `subject`='4. - 6. Juni  2010';  
  global $prefix, $db, $dbname, $br;  
  global $dpnfftscd,$dpnfsubj,$dpnfsuRe,$dpnfsuReMsg,$dpnfsuReDb;
  global $savmsg, $dupechkscnd;  
  
  // test seconds 0=no, 1=yes   17 or 18 chars
  // 01 Sep 09  01:02:00

  // TEST all   ftscdate (maybe mismatched), subject (may include Umlauts, escaped chars, RE's)

  $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$subj."';";
  // echo $short2U."\r\n";
  $res1 = $db->sql_query($q1);
  if ($row1 = $db->sql_fetchrow($res1)) {
    // no problem with escaped subject, no problems with included Re:'s
    $db->sql_freeresult($res1);
    return 1;     
  } else {
    // problem with escaped subject ?, problem with Re:'s, problem with Umlauts ?
    // if (preg_match("/Re[\^d{1,2}]:/",$subj))

    // store detection result, maybe we need it later
    $refnd = refn(0,$subj); 

    if ($refnd) {
      // Re:'s detected
      // Subject includes Re's
      // while (substr($subj,0,3)=="Re:") {
      //   $subj = trim(substr($subj,at("Re:",$subj)+3));
      // }
      // strip Re's
      $strpsubj = refn(1,$subj,"");

      $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$strpsubj."';";
      $res1 = $db->sql_query($q1);
      if ($row1 = $db->sql_fetchrow($res1)) {
        $db->sql_freeresult($res1);
        // problem with Re solved
        logfile('D', "dupe found [Re: in source subject stripped]: ".$msgf);      
        return 2;
      // } else { // maybe RE is ok, and there are (addtl.) other errors ? }
      }
    } else {
      // no re found, may be Re in database records ?
      $addresubj = "Re: ".$subj;

      $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$addresubj."';";
      $res1 = $db->sql_query($q1);
      if ($row1 = $db->sql_fetchrow($res1)) {
        $db->sql_freeresult($res1);
        // problem with Re solved, by adding missing Re cause entry in database includes Re 
        logfile('D', "dupe found [Re: to source subject added]: ".$msgf);
        return 2;
      } else {
        // addtl. Re variations ?
        $addresubj = "Re^2: ".$subj;

        $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$addresubj."';";
        $res1 = $db->sql_query($q1);
        if ($row1 = $db->sql_fetchrow($res1)) {
          $db->sql_freeresult($res1);
          // problem with Re solved, by adding missing Re cause entry in database includes Re 
          logfile('D', "dupe found [Re^2: to source subject added]: ".$msgf);
          return 2;
        } else {
          // addtl. Re variations ?
          $addresubj = "Re^3: ".$subj;

          $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$addresubj."';";
          $res1 = $db->sql_query($q1);
          if ($row1 = $db->sql_fetchrow($res1)) {
            $db->sql_freeresult($res1);
            // problem with Re solved, by adding missing Re cause entry in database includes Re 
            logfile('D', "dupe found [Re^3: to source subject added]: ".$msgf);
            return 2;
          } else {
            // addtl. Re variations ?
            $addresubj = "Re^4: ".$subj;

            $q1 = "select id from ".$dbname.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$addresubj."';";
            $res1 = $db->sql_query($q1);
            if ($row1 = $db->sql_fetchrow($res1)) {
              $db->sql_freeresult($res1);
              // problem with Re solved, by adding missing Re cause entry in database includes Re 
              logfile('D', "dupe found [Re^4: to source subject added]: ".$msgf);
              return 2;
            } //  else {  // may be there are higher Re^# in database but thats too feasable
                          // probably test addtl. Re variations in last step, search MsgID only              
          }
        }        
      }
    }
    
    // } else {
    // Test on
    // maybe escaped characters ?
    // Umlauts 

/*
      } else {
        // last test, against MsgID only
        // test msgid only (if not empty)
        if ($msgid!="") {
          $q1 = "select * from ".$dbname.".echo_".substr($fld,0,1)." where `msgid`='".$msgid."';";
          $res1 = $db->sql_query($q1);
          if ($row1 = $db->sql_fetchrow($res1)) {
            // $msgf,$fld,$fdat,$msgid,$subj
            $ffdat = $row1['ftscdate'];
            $fsubj = $row1['subject'];
            logfile('D', "Mail content mismatch MsgId found: ".$msgf);
            if (substr($fdat,0,19)!=substr($ffdat,0,19)) {
              $dpnfftscd++;          
              logfile('D', "- FTSCDATE expected: ".substr($fdat,0,19));
              logfile('D', "- FTSCDATE found   : ".substr($ffdat,0,19));
            }
            // problem with Re: at start of string
            if ($subj!=$fsubj) {
              if (strlen($subj)>strlen($fsubj)) {
                // RE: in subj ?
                if ( ("Re:"==substr($subj,0,3)) and ( at($fsubj,$subj) > 0 ) ) {
                  $dpnfsuRe++;              
                  $dpnfsuReMsg++;              
                  logfile('D', "- SUBJECT RE difference in msg: ".$subj);
                } else {
                  $dpnfsubj++;
                  logfile('D', "- SUBJECT  expected: ".$subj);
                  logfile('D', "- SUBJECT  found   : ".$fsubj);
                }             
              } elseif (strlen($subj)<strlen($fsubj)) {
                // RE: in fsubj ?
                if (("Re:"==substr($fsubj,0,3)) and ( at($subj,$fsubj)>0 ) ) {
                  $dpnfsuRe++;
                  $dpnfsuReDb++;                              
                  logfile('D', "- SUBJECT RE difference in db: ".$fsubj);
                } else {
                  $dpnfsubj++;
                  logfile('D', "- SUBJECT  expected: ".$subj);
                  logfile('D', "- SUBJECT  found   : ".$fsubj);
                }             
              }
            }        
            $db->sql_freeresult($res1);
            return 3;
          } else {
            return 0;
          }     
        } else {
          logfile('D', "Missing MsgID prevents dupecheck: ".$msgf);
          return 0;
        }
      }
*/        
        
  }
}

//    if (savemsg($ftscdateA,$datetime,$folder,$fromnode,$tonode,$fromname,$toname,$subject,$cattrib,$msgid,$replyid,$origin,$msgpath,$clocal,$crcvd,$csend,$kludges,$body,$seenby,$datewritten,$cuplink)) {
// id         561925,
// $ftscdateA  *ftscdate   '08 Dec 09  21:37:40'   (msg date/time ???)
// $datetime   *datetime   2009-12-08 21:45:22     (???)
// $folder     *folder     'FIDOCON.BLEICHENBACH.1996'
// $fromnode   *fromnode   '2:244/1120@fidonet'     pkt-from transfer
// $tonode     *tonode     '2:2443/1313'            pkt-to   transfer
// $fromname   *fromname   'Tina Kramp'
// $toname     *toname     'Michael Muetterlein'
// $subject    *subject    'allein im Echo'
// $cattrib    c attrib     0
// $msgid      *msgid      '2:240/2188.262 4b1eb95e'
// $replyid    *replyid    '2:244/1117 960ba4e5'
// $origin     *origin     'www.fido-deluxe.de.vu    Fido-Paket -IP- deluxe (2:240/2188.262)'
// $msgpath    *path       '240/2188 244/1120'
// $clocal     c local      'N'
// $crcvd      c rcvd       'Y'
// $csend      c send       'N'
// $kludges    *kludges    ''   (blob)   01h...0Dh 0Ah 01h ... 0Dh 0Ah 01h ... 0Dh 0Ah  all Ctrl+A lines w/o seenby
// $body       *body       ''   (blob)   AREA:FIDOCON.BLEICHENBACH.1996 0Dh 01h ...  incl. header kludges w/o origin
// $seenby     *seenby     ''   (blob)   ...  0Dh
// $datewritten *datewritten '2009-12-08 21:37:40'      (import date/time)
// $cuplink    c Uplink     0                            ???
function savemsg($msgf,$ftscdateA,$datetime,$folder,$fromnode,$tonode,$fromname,$toname,$subject,$cattrib,$msgid,$replyid,$origin,$msgpath,$clocal,$crcvd,$csend,$kludges,$body,$seenby,$datewritten,$cuplink) {
  global $prefix, $db, $dbname, $br;
  global $imperr;  
  global $savmsg, $dupechkscnd;  
  $tbl = "echo_".substr($folder,0,1);
  // eliminate Re:'s from subject
  while (substr($subject,0,3)=="Re:") {
    $subject = trim(substr($subject,at("Re:",$subject)+3));
  } 
  $insert1 = "INSERT INTO ".$dbname.".".$tbl." VALUES (NULL,'".$ftscdateA."', '".$datetime."', '".$folder."', '".$fromnode."', '".$tonode."','".$fromname."', '".$toname."', '".$subject."', ".$cattrib.", '".$msgid."', '".$replyid."', '".$origin."','".$msgpath."', '".$clocal."', '".$crcvd."', '".$csend."', '".$kludges."', '".$body."', '".$seenby."', '".$datewritten."',".$cuplink.")";
  if ($savmsg) {
    if (!$db->sql_query($insert1)) {
      $imperr++;
      logfile('E',"insert message failed: ".$msgf);
      logfile('L',"insert message failed: ".$msgf);
      logfile('D',"insert message failed: ".$msgf);
      $sqle = $db->sql_error($insert1);
      logfile('D',"ERROR: insert record failed '".$tbl."': ".$insert1);
      logfile("D","ERROR: SQL error: (".($sqle['code']).") ".($sqle['message']));
      // echo "Insert failed: Sysop: ".$sn." => ".$sysopshort."\r\n";
    } else {
      // logfile('L', "insert message success: ".$msgf);
      logfile('D', "insert message success: ".$msgf.", table: '".$tbl."', folder: '".$folder."'");
      return True;
    }
  } else {
    logfile('D', "insert message success: ".$msgf.", table: '".$tbl."', folder: '".$folder."'");
    return True;
  }
  return False;
}



function extractmsg($p,$msgf,$folder) {
  global $imperr,$dpnfftscd,$dpnfsubj,$dpnfsuRe,$dpnfsuReMsg,$dpnfsuReDb;
  global $savmsg, $dupechkscnd;  
  
  $fn = $p.$msgf;

  //  *.msg structure see  FTS-0001
  //  http://ambrosia60.dnsalias.net/structs/msg.htm

  // $chr0  = chr(0);
  // $chr1  = chr(1);    // Ctrl+A Kludge
  // $chr13 = chr(13);   // Line Termination
  
  // $fromname = substr($content,0,36);  // incl. 00h
  // $toname   = substr($content,36,36); // incl. 00h
  // $subject  = substr($content,72,72); // incl. 00h
  // $ftscdate = substr($content,144,20); // incl. 00h
  
  // $fromname = substr($fromname,0,at($chr0,$fromname));
  // $toname   = substr($toname,0,at($chr0,$toname));
  // $subject  = substr($subject,0,at($chr0,$subject));
  // $ftscdate = substr($ftscdate,0,at($chr0,$ftscdate));

  // echo $fromname."\r\n";
  // echo $toname."\r\n";
  // echo $subject."\r\n";
  // echo $ftscdate."\r\n";  
  
  
//                               Stored Message
//
//       Offset
//      dec hex
//              .-----------------------------------------------.
//        0   0 |                                               |
//              ~                 fromUserName                  ~
//              |                   36 bytes                    |
//              +-----------------------+-----------------------+
//       36  24 |                                               |
//              ~                  toUserName                   ~
//              |                   36 bytes                    |
//              +-----------------------+-----------------------+
//       72  48 |                                               |
//              ~                    subject                    ~
//              |                   72  bytes                   |
//              +-----------------------+-----------------------+
//      144  90 |                                               |
//              ~                    DateTime                   ~
//              |                    20 bytes                   |
//              +-----------------------+-----------------------+
//      164  A4 | timesRead (low order) | timesRead (high order)|
//              +-----------------------+-----------------------+
//      166  A6 | destNode (low order)  | destNode (high order) |
//              +-----------------------+-----------------------+
//      168  A8 | origNode (low order)  | origNode (high order) |
//              +-----------------------+-----------------------+
//      170  AA |   cost (low order)    |   cost (high order)   |
//              +-----------------------+-----------------------+
//      172  AC | origNet (low order)   | origNet (high order)  |
//              +-----------------------+-----------------------+
//      174  AE | destNet (low order)   | destNet (high order)  |
//              +-----------------------+-----------------------+
//      176  B0 | destZone (optional)   | destZone (optional)   |
//              +-----------------------+-----------------------+
//      178  B2 | origZone (optional)   | origZone (optional)   |
//              +-----------------------+-----------------------+
//      180  B4 | destPoint(optional)   | destPoint(optional)   |
//              +-----------------------+-----------------------+
//      182  B6 | origPoint(optional)   | origPoint(optional)   |
//              +-----------------------+-----------------------+
//      184  B8 |  replyTo (low order)  |  replyTo (high order) |
//              +-----------------------+-----------------------+
//      186  BA | Attribute (low order) | Attribute (high order)|
//              +-----------------------+-----------------------+
//      188  BC | nextReply (low order) | nextReply (high order)|
//              +-----------------------+-----------------------+
//      190  BE |                      text                     |
//              ~                    unbounded                  ~
//              |                 null terminated               |
//              `-----------------------------------------------'
//
//      Message    = fromUserName(36)  (* Null terminated *)
//                   toUserName(36)    (* Null terminated *)
//                   subject(72)       (* see FileList below *)
//                   DateTime          (* message body was last edited *)
//                   timesRead         (* number of times msg has been read *)
//                   destNode          (* of message *)
//                   origNode          (* of message *)
//                   cost              (* in lowest unit of originator's
//                                        currency *)
//                   origNet           (* of message *)
//                   destNet           (* of message *)
//                   destZone          (* of message *)
//                   origZone          (* of message *)
//                   destPoint         (* of message *)
//                   origPoint         (* of message *)
//                   replyTo           (* msg to which this replies *)
//                   AttributeWord
//                   nextReply         (* msg which replies to this *)
//                   text(unbounded)   (* Null terminated *)
//
//      DateTime   = (* a character string 20 characters long *)
//                                     (* 01 Jan 86  02:34:56 *)
//                   DayOfMonth " " Month " " Year " "
//                   " " HH ":" MM ":" SS
//                   Null
  
  

	$size = filesize($fn);
	$f = fopen($fn,'r');

  //	$result = new C_msgheader;
//        0   0 |                                               |
//              ~                 fromUserName                  ~
//              |                   36 bytes                    |
  $fromname = strtok(fread($f, 36), chr(0));

//       36  24 |                                               |
//              ~                  toUserName                   ~
//              |                   36 bytes                    |
  $toname   = strtok(fread($f, 36), chr(0));

//       72  48 |                                               |
//              ~                    subject                    ~
//              |                   72  bytes                   |
  $subjectraw  = strtok(fread($f, 72), chr(0));
  $subject = $subjectraw;

//      144  90 |                                               |
//              ~                    DateTime                   ~
//              |                    20 bytes                   |
  $ftscdateA = fgetasciiz($f);
  $ftscdate = Fts_date_to_unix($ftscdateA);
  $ADate    = 0;


//      164  A4 | timesRead (low order) | timesRead (high order)|
  $timesRead = fgetint($f,2);

//              +-----------------------+-----------------------+
//      166  A6 | destNode (low order)  | destNode (high order) |
  $destNode = fgetint($f,2);

//              +-----------------------+-----------------------+
//      168  A8 | origNode (low order)  | origNode (high order) |
  $origNode = fgetint($f,2);

//              +-----------------------+-----------------------+
//      170  AA |   cost (low order)    |   cost (high order)   |
  $cost = fgetint($f,2);

//              +-----------------------+-----------------------+
//      172  AC | origNet (low order)   | origNet (high order)  |
  $origNet = fgetint($f,2);

//              +-----------------------+-----------------------+
//      174  AE | destNet (low order)   | destNet (high order)  |
  $destNet = fgetint($f,2);

//              +-----------------------+-----------------------+
//      176  B0 | destZone (optional)   | destZone (optional)   |
  $destZone = fgetint($f,2);

//              +-----------------------+-----------------------+
//      178  B2 | origZone (optional)   | origZone (optional)   |
  $origZone = fgetint($f,2);

//              +-----------------------+-----------------------+
//      180  B4 | destPoint(optional)   | destPoint(optional)   |
  $destPoint = fgetint($f,2);

//              +-----------------------+-----------------------+
//      182  B6 | origPoint(optional)   | origPoint(optional)   |
  $origPoint = fgetint($f,2);

//              +-----------------------+-----------------------+
//      184  B8 |  replyTo (low order)  |  replyTo (high order) |
//              +-----------------------+-----------------------+
  $replyTo = fgetint($f,2);


//      186  BA | Attribute (low order) | Attribute (high order)|
//              +-----------------------+-----------------------+
//  fseek($f,186);
  $arr = unpack("vattrs", fread($f,2));
  $Attrs = FTS_to_Flag($arr["attrs"]);


//      188  BC | nextReply (low order) | nextReply (high order)|
//              +-----------------------+-----------------------+
  $nxtReply = fgetint($f,2);


//      190  BE |                      text                     |
//              ~                    unbounded                  ~
//              |                 null terminated               |
//  fseek($f,0xbe);
  $message = strtok(fread($f,$size-0xbe), chr(0));

  fclose($f);


  // from/to doesn't work that way ... 2-dimensional or use orig
  // db from/to is the packet from/to   i.e.  244/1120 to 2443/1313
  // importing *.msg is only OWNAKA available ...  ??? to 244/1120
  // source = last entry from path ?!?
/*  
  if ($origPoint==0) {
    echo "From: ".$fromname."(".$origZone.":".$origNet."/".$origNode.")\r\n";
  } else {
    echo "From: ".$fromname."(".$origZone.":".$origNet."/".$origNode.".".$origPoint.")\r\n";
  }

  if ($destPoint==0) {
    echo "To  : ".$toname."(".$destZone.":".$destNet."/".$destNode.")\r\n";
  } else {
    echo "To  : ".$toname."(".$destZone.":".$destNet."/".$destNode.".".$destPoint.")\r\n";
  }
*/

  // there is no PKT date, use msg date instead
  $datetime = date('Y-m-d H:i:s',strtotime($ftscdateA));

/*  
  echo "From: ".$fromname."\r\n";
  echo "To  : ".$toname."\r\n";

  echo "Subj: ".$subject."\r\n";
  echo "Date: ".$ftscdateA."\r\n";  
  echo "Datetime: ".$datetime."\r\n";

  echo "Times Read: ".$timesRead."\r\n";
  echo "Cost      : ".$cost."\r\n";
  echo "Attributs : ".$Attrs."\r\n";
  echo "Reply-To  : ".$replyTo."\r\n";
  echo "NextReply : ".$nxtReply."\r\n";
 */
 
// id         561925,
// $ftscdateA  *ftscdate   '08 Dec 09  21:37:40'   (msg date/time ???)
// $datetime   *datetime   2009-12-08 21:45:22     (???)
// $folder     *folder     'FIDOCON.BLEICHENBACH.1996'
// $fromnode   *fromnode   '2:244/1120@fidonet'     pkt-from transfer
// $tonode     *tonode     '2:2443/1313'            pkt-to   transfer
// $fromname   *fromname   'Tina Kramp'
// $toname     *toname     'Michael Muetterlein'
// $subject    *subject    'allein im Echo'
// $cattrib    c attrib     0
// $msgid      *msgid      '2:240/2188.262 4b1eb95e'
// $replyid    *replyid    '2:244/1117 960ba4e5'
// $origin     *origin     'www.fido-deluxe.de.vu    Fido-Paket -IP- deluxe (2:240/2188.262)'
// $msgpath    *path       '240/2188 244/1120'
// $clocal     c local      'N'
// $crcvd      c rcvd       'Y'
// $csend      c send       'N'
// $kludges    *kludges    ''   (blob)   01h...0Dh 0Ah 01h ... 0Dh 0Ah 01h ... 0Dh 0Ah  all Ctrl+A lines w/o seenby
// $body       *body       ''   (blob)   AREA:FIDOCON.BLEICHENBACH.1996 0Dh 01h ...  incl. header kludges w/o origin
// $seenby     *seenby     ''   (blob)   ...  0Dh
// $datewritten *datewritten '2009-12-08 21:37:40'      (import date/time)
// $cuplink    c Uplink     0                            ???

// constants
  $cattrib = 0;
  $clocal  = "N";
  $crcvd   = "Y";
  $csend   = "N";
  $cuplink = 0;
  
//  print_r($Attrs);
  $msgid = "";
  $replyid = "";
  $origin  = "";
  $msgpath = "";
  $kludges = "";
  $body    = "AREA:".$folder;
  $seenby  = "";
  $fromnode = "";
  
  $msgline = explode("\r",$message);
  foreach ($msgline as $m) {
    // echo $m."\r\n";
    if (substr($m,0,1)==chr(1)) {
      // all Ctrl+A Kludges
      // switch () {
      // }
      if (substr($m,1,7)=="REPLY: ") {
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;
        $replyid  = substr($m,8);     
      } elseif (substr($m,1,7)=="MSGID: ") {
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;
        $msgid    = substr($m,8); 
      } elseif (substr($m,1,5)=="PID: ") {
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;
      } elseif (substr($m,1,6)=="CHRS: ") {
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;
      } elseif (substr($m,1,5)=="TID: ") {
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;
      } elseif (substr($m,1,6)=="PATH: ") {
        $kludges .= $m."\r\n";
        if ($msgpath=='') {
          $msgpath .= substr($m,7);
        } else {
          $msgpath .= chr(13).substr($m,7);        
        }
      } else {
        // unknown kludge
        $kludges .= $m."\r\n";
        $body    .= chr(13).$m;       
      }
    } else {
      if (substr($m,0,11)==" * Origin: ") {
        $origin  = substr($m,11);
        if (preg_match('/\(([0-6]+):([0-9]+)\/([0-9]+)\.([0-9]+)\)/',$origin,$origAKA)) {        
          // found
        } elseif (preg_match('/\(([0-6]+):([0-9]+)\/([0-9]+)\)/',$origin,$origAKA)) {
          // found
        } else {
          logfile('E', "Error: Origin w/o AKA: ".$msgf.", Origin: '".$origin."'");
          logfile('D', "Error: Origin w/o AKA: ".$msgf.", Origin: '".$origin."'");
          if (preg_match('/([0-6]+):([0-9]+)\/([0-9]+)\.([0-9]+)/',$msgid,$origAKA)) {
            // try msgid
            logfile('D', "Error: Origin w/o AKA, found MsgID: ".$msgf.", MsgID: '".$msgid."'");
            if (isset($origAKA[0])) {          
              logfile('D', "  MsgID arr[0]: ".$msgf.", arr0: '".$origAKA[0]."'");
            }
            /*          
            if (isset($origAKA[1])) {
              logfile('D', "  MsgID arr[1]: ".$msgf.", arr1: '".$origAKA[1]."'");
            }
            if (isset($origAKA[2])) {            
              logfile('D', "  MsgID arr[2]: ".$msgf.", arr2: '".$origAKA[2]."'");
            }
            if (isset($origAKA[3])) {                      
              logfile('D', "  MsgID arr[3]: ".$msgf.", arr3: '".$origAKA[3]."'");
            }
            if (isset($origAKA[4])) {            
              logfile('D', "  MsgID arr[4]: ".$msgf.", arr4: '".$origAKA[4]."'");
            }
            */
          } else {          
            logfile('D', "Error: Origin w/o AKA, empty MsgID: ".$msgf);
            $origAKA[0] = "";
            $origAKA[1] = "";
            $origAKA[2] = "";
            $origAKA[3] = "";
            $origAKA[4] = "";
          }          
        }
        $fromnode = Get_origin_address($origAKA,$msgf);
      } elseif (substr($m,0,9)=="SEEN-BY: ") {
        $seenby  .= $m.chr(13);     
      } else {
        $body    .= chr(13).$m;
      }    
    }
  }
  
  // fromnode =>  last path entry ?
  // if fromnode = OWNAKA
  // otherwise get_aka_from_origin                         should be
  // sample: PGP  (2:2448/44.23)  path: 2448/44  !=        2:2448/44
  //         MM   (2:244/1117)    path: 244/1117           2:244/1117
  //         Kuno (2:240/4030)    path: 240/4030           2:240/4030
  //         Kees (2:280/5003.4)  path: 280/5003           2:280/5003                            
  //         Herm.(2:244/1120.21) path: 244/1120 !=        2:244/1120.21
  //         Tom  (2:244/1120.6)  !path:         !=        2:244/1120.6
  //         Tina (2:240/2188.262) path: 240/2188 !=       2:240/2188.262

  // exceptions
  if ($fromnode=="2:2448/44.23") {
    $fromnode = "2:2448/44";
  } elseif ($fromnode=="2:280/5003.4") {
    $fromnode = "2:280/5003";
  }
  // missing messages via 2443/1313
  // path: 2448/44 2432/200 2443/1313
  if (preg_match('/.* 2443\/1313$/',$msgpath,$lastpAKA)) {
    $fromnode = "2:2443/1313";    
  }
  // path: 2448/44 2432/200 2443/1313
  if (preg_match('/.* 244\/1111$/',$msgpath,$lastpAKA)) {
    $fromnode = "2:244/1111";    
  }
  // path 244/1117 1500 1111
  if (preg_match('/.* 1111$/',$msgpath,$lastpAKA)) {
    $fromnode = "2:244/1111";    
  }  
  
  // $fromnode = OWNAKA;
  $tonode   = OWNAKA;
  // echo $message."\r\n";

/*  
  echo "MsgID: ".$msgid."\r\n";
  echo "ReplyID: ".$replyid."\r\n";
 */
//  echo "Kludges: ".$kludges."\r\n";
//  echo $body."\r\n";
/*
  echo "Origin: ".$origin."\r\n";
  echo "Seen-By: ".$seenby."\r\n";
  echo "MsgPath: ".$msgpath."\r\n";
  echo "FromAKA: ".$fromnode."\r\n";
  echo "ToAKA: ".$tonode."\r\n";
 */

  // all vars set
  
  // check if dupe
  // SELECT * FROM fidobase2.echo_f where `folder`='FIDOCON.BLEICHENBACH.1996' and `ftscdate` like '08 Dec 09  21:20:4%' and `msgid`='2:240/2188.262 4b1eb5bf' and `subject`='4. - 6. Juni  2010';  

  //  problem '\'  ?
  $body    = str_replace(chr(92),chr(92).chr(92),$body);
  $subject = str_replace(chr(92),chr(92).chr(92),$subject);
  $origin  = str_replace(chr(92),chr(92).chr(92),$origin);

  $body    = preg_replace("/'/","\'",$body);
  $subject = preg_replace("/'/","\'",$subject);
  $origin  = preg_replace("/'/","\'",$origin);
  $df = dupefind($msgf,$folder,$ftscdateA,$msgid,$subject);
  if ($df == 0) {
    // save msg to db
    $datewritten = date('Y-m-d H:i:s'); 
    // echo "Now: ".$datewritten."\r\n";

    // echo "save message to db\r\n";
    if (savemsg($msgf,$ftscdateA,$datetime,$folder,$fromnode,$tonode,$fromname,$toname,$subject,$cattrib,$msgid,$replyid,$origin,$msgpath,$clocal,$crcvd,$csend,$kludges,$body,$seenby,$datewritten,$cuplink)) {
      echo $msgf." => stored.\r\n";
      return True;
    } else {
      echo $msgf." => WARNING: message import failed. See Error log.\r\n";
    }
  } else {
    if ($df > 1) {
      logfile('D',"dupe found: ".$msgf." (".($df==2?"-RE":"MsgID").")");
    }    
    // echo "exists.\r\n";
  }

  // verification
  // if (!dupefind("FIDOCON.BLEICHENBACH.1996","04 Dec 09  11:17:00","2:2448/44.23@fidonet 671f9ec5","traffic")) {
  //   echo "VTEST: save message to db\r\n";
  // } else {
  //   echo "VTEST: dupe found\r\n";  
  // }
  return False;
}

function _int_sort($a,$b)
{
	if ($a<$b) return -1;
	if ($a>$b) return 1;
	return 0;
}


// -----------------------------------------

function fb2imain1($folder="",$path="",$testmode=False) {
  global $prefix, $db, $br;
  global $fbbs,$homepage, $baseurl, $areapath, $areap2, $prog, $sitename, $email;
  global $AllowableHTML, $locale;
  global $SRC_PATH, $imperr,$dpnfftscd,$dpnfsubj,$dpnfsuRe,$dpnfsuReMsg,$dpnfsuReDb;
  global $savmsg, $dupechkscnd;  
  
  echo "Import: ".$folder." => ".$path."\r\n";
  logfile('E',"Import: ".$path);
  logfile('L',"Import: ".$folder." => ".$path);
  logfile('D',"Import: folder ".$folder);
  logfile('D',"Import: path   ".$path);
  
  // if (!xinclude('C_opus.php')) { echo "xinclude C_opus failed.\r\n"; }

  // walk thru directory
  // *.msg => regexp: /^\d\.msg$/
  $rstr = "/^\d{1,8}\.msg$/i";

//  $blocksdir = dir($path);
//  while($func=$blocksdir->read()) {
//   $file = strtolower($func);
//   if (($func!=".") and ($func!="..") and is_dir($path.$func)) {
//     // is directory entry, skip
//   } else {
//     if (($func!=".") and ($func!="..")) {
//       if (preg_match($rstr,$file)) {
//         // file_get_contents -- Reads entire file into a string
//         // $input = file($path.$func);
//         echo $path.$func."\r\n";
//         if ($func=="999.msg") {
//           importmsg($path.$func);
//         }
//       }
//     } 
//   }
// }
// closedir($blocksdir->handle);

  $array = array();
  $this->path = $path;
  if ($dir = @opendir($path)) {
    // echo $dir."\r\n";
    while($file = readdir($dir)) {
      // echo $file.", ".file_exists($path.$file)."\r\n";
      if (file_exists($path.$file) && preg_match('/^[0-9]+\.msg$/i',$file)) {
        @$array[(int)strtok($file,'.')] = $file;
        // echo $file."\r\n";
      }
    }
    uksort($array,'_int_sort');
    $this->_list = array_values($array);
    $cntmsg = sizeof($this->_list);
    // echo $cntmsg."\r\n";
    // foreach($this->_list as $f) print "$f\n";
    $impsucc = 0;
    $impskp  = 0;
    $imperr  = 0;
    $dpnfftscd = 0;
    $dpnfsubj  = 0;
    $dpnfsuRe  = 0;
    $dpnfsuReMsg  = 0;
    $dpnfsuReDb   = 0;
        
    // $body = "MK> Anm.: Mail koennt' verspaetet kommen, 2:24/999 nimmt seit Samstag";
    // echo $body."\r\n";
    // $body = preg_replace("/'/","\'",$body);
    // echo $body."\r\n";

    // $subject = chr(92);
    // echo $subject."\r\n";
    // $subject = str_replace(chr(92),"\\",$subject);
    // echo $subject."\r\n";

    // $subject = chr(92);
    // echo $subject."\r\n";
    // $subject = str_replace(chr(92),chr(92).chr(92),$subject);
    // echo $subject."\r\n";


    foreach($this->_list as $f) {
      // 8951          $cntmsg-1
      // $f = $this->_list[8950];
      // echo $f." => ";
      if (extractmsg($path,$f,$folder)) {
        $impsucc++;
        // break;
      } else {
        $impskp++;
      }      
    }
 
 
    // return 1;  ok
    if ($dpnfftscd > 0) {
      logfile('D', "FTSCDATE differences: ".$dpnfftscd);
    }
    if ($dpnfsubj > 0) {
      logfile('D', "SUBJECT differences: ".$dpnfsubj);
    }
    if ($dpnfsuRe > 0) {
      logfile('D', "SUBJECT 'RE:' differences: ".$dpnfsuRe);
      logfile('D', "SUBJECT 'RE:' differences source MSG: ".$dpnfsuReMsg);          
      logfile('D', "SUBJECT 'RE:' differences source DB : ".$dpnfsuReDb);
    }        
    logfile('L',"Messages imported: ".$impsucc.", skipped: ".$impskp.", error: ".$imperr);
    logfile('D',"Messages imported: ".$impsucc.", skipped: ".$impskp.", error: ".$imperr);
    return TRUE;
  } else {
    // return 0;  could not open path
    echo "Could not open path: ".$path."\r\n";
    logfile('E',"Could not open path. Path doesn't exist: ".$path);
    logfile('D',"Could not open path. Path doesn't exist: ".$path);
    return FALSE;
  }
  return TRUE;
}

/* ---------  end funtions  ------------------------------ */


?>
